<script>
  import { json } from "d3-fetch";
  import { onMount } from "svelte";
  import CircleG from "./_design_2_circle.svelte";

  // Load the data
  let data, dataChicago, dataBaltimore, dataLA = null;
  let resBaltimore = [];
  let resChicago = [];
  let resLA = [];
  let maxValue = 0;
  onMount(async () => {
    data = await json("/data/daily_heating_cooling.json");
    dataBaltimore = data.filter(function (el) {
      return el.city == "Baltimore";
    })
    dataChicago = data.filter(function (el) {
      return el.city == "Chicago";
    })
    dataLA  = data.filter(function (el) {
      return el.city == "Los Angeles";
    })
    let keys = ['heating', 'cooling']
    // let m1 = data.reduce(
    //   (prev, curr) => (keys.forEach(k => prev[k] += curr[k]), prev), 
    //   Object.fromEntries(keys.map(k => [k, 0]))); 
    // console.log(data)
    // console.log(m1)

    function getMonthlyData(data, result) {
      data.reduce(function(res, value) {
        if (!res[value.month]) {
          res[value.month] = { month: value.month, heating: 0, cooling: 0 };
          result.push(res[value.month])
        }
        res[value.month].heating += value.heating;
        res[value.month].cooling += value.cooling;
        return res;
      }, {});
      console.log(result);
      return result;
    }
    
    let heating_m = 0;
    let cooling_m = 0;
    resBaltimore = getMonthlyData(dataBaltimore, resBaltimore);
    heating_m = Math.max.apply(Math, resBaltimore.map(function(o) { return o.heating; }));
    cooling_m = Math.max.apply(Math, resBaltimore.map(function(o) { return o.cooling; }));
    maxValue = Math.max(heating_m, cooling_m);
    resChicago = getMonthlyData(dataChicago, resChicago);
    heating_m = Math.max.apply(Math, resChicago.map(function(o) { return o.heating; }));
    cooling_m = Math.max.apply(Math, resChicago.map(function(o) { return o.cooling; }));
    maxValue = Math.max(heating_m, cooling_m, maxValue);
    resLA = getMonthlyData(dataLA, resLA);
    heating_m = Math.max.apply(Math, resLA.map(function(o) { return o.heating; }));
    cooling_m = Math.max.apply(Math, resLA.map(function(o) { return o.cooling; }));
    maxValue = Math.max(heating_m, cooling_m, maxValue);
  });


  // Size and margins
  const width = 600;
  const height = 250;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
</script>

<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
    <CircleG data={resBaltimore} selectedCity="Baltimore" maxValue={maxValue} shiftX={-200}/>
    <CircleG data={resChicago} selectedCity="Chicago" maxValue={maxValue} shiftX={0}/>
    <CircleG data={resLA} selectedCity="Los Angeles" maxValue={maxValue} shiftX={200}/>
  </g>
</svg>

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
</style>
